.nolist
include \masm32\include\masm32rt.inc

WinMain	PROTO :DWORD,:DWORD,:DWORD,:DWORD
WndProc	PROTO :DWORD,:DWORD,:DWORD,:DWORD
TopXY		PROTO   :DWORD,:DWORD
CrtRichEdit	PROTO   :DWORD,:DWORD
File2Buf	PROTO :DWORD
ShowNum	PROTO :DWORD	; show a number, e.g. ShowNum eax

crlf	EQU 13, 10
.data?
EspGlob		dd ?
RetBuffer	db 256 dup (?)
ClBuffer		db 256 dup (?)
pShowNum	dd ?	; pointer to NumBuf in dwtoaBuf
pDwToA		dd ?	; pointer to dwtoaBuf
dwtoaBuf	db 80 dup (?)		; ca. 48 for the number, rest for "here is your number..."
BufStart	dd ?

.data
	szDisplayName db "Generic",0
	CommandLine   dd 0
	hWnd          dd 0
	hInstance     dd 0

	hwndEdit	dd 0
	hLib		dd 0
	hMem		dd 0
.code

;read-only data before start

Def_File  	db "RichEd.asm",0
NumBuf		db "A number for you:", crlf, crlf,0
AppName		db "Testing RichEd",0
MyVar			dd 0

start:
	push esi
	mov esi, offset dwtoaBuf
	mov pShowNum, esi
	invoke szCopy, addr NumBuf, esi
	add esi, len(esi)
	mov pDwToA, esi	; pointer to the dwtoa buffer used inter alia by GetSetProfile
	pop esi

	invoke GetModuleHandle, NULL ; provides the instance handle
	mov hInstance, eax
	invoke GetCL, 1,	addr ClBuffer
	.if eax!=1
	invoke lstrcpy, addr ClBuffer, addr Def_File
	.endif
	; invoke MessageBox, 0, addr ClBuffer, addr AppName, MB_OK

	invoke GetCommandLine        ; provides the command line address
	mov CommandLine, eax

	invoke WinMain,hInstance,NULL,CommandLine,SW_SHOWDEFAULT

	invoke ExitProcess,0

WinMain proc hInst     :DWORD,
             hPrevInst :DWORD,
             CmdLine   :DWORD,
             CmdShow   :DWORD

        ;====================
        ; Put LOCALs on stack
        ;====================

        LOCAL wc   :WNDCLASSEX
        LOCAL msg  :MSG

        LOCAL Wwd  :DWORD
        LOCAL Wht  :DWORD
        LOCAL Wtx  :DWORD
        LOCAL Wty  :DWORD

        szText szClassName,"Generic_Class"

        ;==================================================
        ; Fill WNDCLASSEX structure with required variables
        ;==================================================

        mov wc.cbSize,         sizeof WNDCLASSEX
        mov wc.style,          CS_HREDRAW or CS_VREDRAW \
                               or CS_BYTEALIGNWINDOW
        mov wc.lpfnWndProc,    offset WndProc      ; address of WndProc
        mov wc.cbClsExtra,     NULL
        mov wc.cbWndExtra,     NULL
        m2m wc.hInstance,      hInst               ; instance handle
        mov wc.hbrBackground,  COLOR_BTNFACE+1     ; system color
        mov wc.lpszMenuName,   NULL
        mov wc.lpszClassName,  offset szClassName  ; window class name
          invoke LoadIcon,hInst,500    ; icon ID   ; resource icon
        mov wc.hIcon,          eax
          invoke LoadCursor,NULL,IDC_ARROW         ; system cursor
        mov wc.hCursor,        eax
        mov wc.hIconSm,        0

        invoke RegisterClassEx, ADDR wc     ; register the window class

        ;================================
        ; Centre window at following size
        ;================================

        mov Wwd, 700
        mov Wht, 550

        invoke GetSystemMetrics,SM_CXSCREEN ; get screen width in pixels
        invoke TopXY,Wwd,eax
        mov Wtx, eax

        invoke GetSystemMetrics,SM_CYSCREEN ; get screen height in pixels
        invoke TopXY,Wht,eax
        mov Wty, eax

        ; ==================================
        ; Create the main application window
        ; ==================================
        invoke CreateWindowEx,WS_EX_OVERLAPPEDWINDOW,
                              ADDR szClassName,
                              ADDR ClBuffer,
                              WS_OVERLAPPEDWINDOW,
                              Wtx,Wty,Wwd,Wht,
                              NULL,NULL,
                              hInst,NULL

        mov   hWnd,eax  ; copy return value into handle DWORD

        invoke LoadMenu,hInst,600                 ; load resource menu
        invoke SetMenu,hWnd,eax                   ; set it to main window

        invoke ShowWindow,hWnd,SW_SHOWNORMAL      ; display the window
        invoke UpdateWindow,hWnd                  ; update the display

      ;===================================
      ; Loop until PostQuitMessage is sent
      ;===================================

    StartLoop:
      invoke GetMessage,ADDR msg,NULL,0,0         ; get each message
      cmp eax, 0                                  ; exit if GetMessage()
      je ExitLoop                                 ; returns zero
      invoke TranslateMessage, ADDR msg           ; translate it
      invoke DispatchMessage,  ADDR msg           ; send it to message proc
      jmp StartLoop
    ExitLoop:

      return msg.wParam

WinMain endp

; #########################################################################

WndProc proc hWin   :DWORD,
             uMsg   :DWORD,
             wParam :DWORD,
             lParam :DWORD

; -------------------------------------------------------------------------
; Message are sent by the operating system to an application through the
; WndProc proc. Each message can have additional values associated with it
; in the two parameters, wParam & lParam. The range of additional data that
; can be passed to an application is determined by the message.
; -------------------------------------------------------------------------

    .if uMsg == WM_COMMAND
    ;----------------------------------------------------------------------
    ; The WM_COMMAND message is sent by menus, buttons and toolbar buttons.
    ; Processing the wParam parameter of it is the method of obtaining the
    ; control's ID number so that the code for each operation can be
    ; processed. NOTE that the ID number is in the LOWORD of the wParam
    ; passed with the WM_COMMAND message. There may be some instances where
    ; an application needs to seperate the high and low words of wParam.
    ; ---------------------------------------------------------------------
    
    ;======== menu commands ========

        .if wParam == 1000
            invoke SendMessage,hWin,WM_SYSCOMMAND,SC_CLOSE,NULL
        .elseif wParam == 1900
            szText TheMsg,"Assembler, Pure & Simple"
            invoke MessageBox,hWin,ADDR TheMsg,ADDR szDisplayName,MB_OK
        .endif

    ;====== end menu commands ======

    .elseif uMsg == WM_CREATE

		invoke File2Buf, addr ClBuffer
		.if eax
		invoke CrtRichEdit, hWin, hInstance
		.endif

    ; --------------------------------------------------------------------
    ; This message is sent to WndProc during the CreateWindowEx function
    ; call and is processed before it returns. This is used as a position
    ; to start other items such as controls. IMPORTANT, the handle for the
    ; CreateWindowEx call in the WinMain does not yet exist so the HANDLE
    ; passed to the WndProc [ hWin ] must be used here for any controls
    ; or child windows.
    ; --------------------------------------------------------------------

    .elseif uMsg == WM_CLOSE
    ; -------------------------------------------------------------------
    ; This is the place where various requirements are performed before
    ; the application exits to the operating system such as deleting
    ; resources and testing if files have been saved. You have the option
    ; of returning ZERO if you don't wish the application to close which
    ; exits the WndProc procedure without passing this message to the
    ; default window processing done by the operating system.
    ; -------------------------------------------------------------------

    ;    szText TheText,"Please Confirm Exit"
    ;    invoke MessageBox,hWin,ADDR TheText,ADDR szDisplayName,MB_YESNO
    ;      .if eax == IDNO
    ;        return 0
    ;      .endif

	; CLEANUP
	.if hMem
		invoke GlobalUnlock, hMem
		invoke GlobalFree, hMem
	.endif
	.if hwndEdit
		invoke DestroyWindow, hwndEdit
	.endif
	.if hLib
		invoke FreeLibrary, hLib
	.endif

    .elseif uMsg == WM_DESTROY
    ; ----------------------------------------------------------------
    ; This message MUST be processed to cleanly exit the application.
    ; Calling the PostQuitMessage() function makes the GetMessage()
    ; function in the WinMain() main loop return ZERO which exits the
    ; application correctly. If this message is not processed properly
    ; the window disappears but the code is left in memory.
    ; ----------------------------------------------------------------
        invoke PostQuitMessage,NULL
        return 0 
    .endif

    invoke DefWindowProc,hWin,uMsg,wParam,lParam
    ; --------------------------------------------------------------------
    ; Default window processing is done by the operating system for any
    ; message that is not processed by the application in the WndProc
    ; procedure. If the application requires other than default processing
    ; it executes the code when the message is trapped and returns ZERO
    ; to exit the WndProc procedure before the default window processing
    ; occurs with the call to DefWindowProc().
    ; --------------------------------------------------------------------

    ret

WndProc endp

; ########################################################################

TopXY proc wDim:DWORD, sDim:DWORD

    ; ----------------------------------------------------
    ; This procedure calculates the top X & Y co-ordinates
    ; for the CreateWindowEx call in the WinMain procedure
    ; ----------------------------------------------------

    shr sDim, 1      ; divide screen dimension by 2
    shr wDim, 1      ; divide window dimension by 2
    mov eax, wDim    ; copy window dimension into eax
    sub sDim, eax    ; sub half win dimension from half screen dimension

    return sDim

TopXY endp

; ########################################################################

CrtRichEdit proc hwndOwner:DWORD, hinst:DWORD
	LOCAL rc:RECT
	invoke GetClientRect, hwndOwner, addr rc
	invoke LoadLibrary, chr$("Riched20.dll")
	.if eax
		mov hLib, eax
		invoke GetModuleHandle,0	; needed for CreateWindowEx
		mov hinst, eax
		invoke CreateWindowEx, 0, chr$("RichEdit20A"), BufStart,
		ES_MULTILINE or WS_VISIBLE or WS_CHILD or WS_BORDER or WS_TABSTOP,
		0, 0, rc.right, rc.bottom,
		hwndOwner, NULL, hinst, NULL
		mov hwndEdit, eax
	.endif
  ret
CrtRichEdit endp

ClearLocals proc	; first instruction after LOCALS - eax will be zero on exit
	pop EspGlob	; save the return address - now the stack is identical to the calling procedure	
	xchg eax,ecx	; save ecx
	mov ecx,ebp	; base page of calling procedure
	sub ecx,esp	; ebp - esp = No. of bytes in locals
	mov esp,ebp	; discard existing locals
	shr ecx,2	; divide by four
@@:	push 0		; dwords on stack
	loop @B
	xchg eax,ecx	; restore ecx
	push EspGlob	; restore the return address
	ret
ClearLocals endp

File2Buf proc Fname:DWORD
LOCAL	bSuccess:DWORD, dwFileSize:DWORD, dwHighSize:DWORD, dwBytesRead:DWORD, hFile:HANDLE
Call ClearLocals
	invoke	CreateFile, Fname, GENERIC_READ,
	FILE_SHARE_READ, 0, OPEN_EXISTING, 0, 0
	mov	hFile,eax

	.IF eax==INVALID_HANDLE_VALUE
	    xor	eax,eax
	    ret
	.ENDIF

	invoke GetFileSize, hFile, ADDR dwHighSize

	.IF dwHighSize
	    invoke CloseHandle, hFile	; we won't deal with 4MB files
	    xor	eax,eax
	    ret
	.ENDIF

	mov dwFileSize, eax

	invoke GlobalAlloc,GMEM_MOVEABLE or GMEM_ZEROINIT, dwFileSize	; Allocate memory
	mov  hMem, eax
	invoke GlobalLock, hMem
	mov BufStart, eax	; pointer to memory
	invoke ReadFile, hFile, BufStart, dwFileSize, ADDR dwBytesRead, 0
	mov bSuccess, eax
	invoke CloseHandle, hFile
	mov eax, dwBytesRead
	.IF eax!=dwFileSize
		invoke MessageBox, 0, chr$("fat problem!"), chr$("Test"), MB_OK
		invoke ShowNum, dwBytesRead
		invoke ShowNum, dwFileSize
		xor eax, eax
	.ENDIF
	ret
File2Buf endp

ShowNum proc Numb:DWORD
	pushad
	  invoke dwtoa,Numb,pDwToA
	  invoke MessageBox,NULL,pShowNum,addr AppName,MB_OKCANCEL
	popad
	ret
ShowNum endp

end start

OPT_SUSY WINDOWS
OPT_ARG1 "C:\WWN\ASM\TESTJJ\Copie (2) de F_Dialogbff.asm"
OPT_icon eye

HWND CreateRichEdit(
    HWND hwndOwner,        // Dialog box handle.
    int x, int y,          // Location.
    int dWidth, int dHeight, // Dimensions.
    HINSTANCE hinst)       // Application or DLL instance.
{
    LoadLibrary(TEXT("Riched20.dll"));
    HWND hwndEdit= CreateWindowEx(0, RICHEDIT_CLASS, TEXT("Type here"),
        ES_MULTILINE or WS_VISIBLE or WS_CHILD or WS_BORDER or WS_TABSTOP, 
        x, y, dWidth, dHeight, 
        hwndOwner, NULL, hinst, NULL);
    return hwndEdit;
}
http://msdn2.microsoft.com/en-us/library/bb787877(VS.85).aspx
